/*
 * Created on 2007/01/10
 *
 *
 * Copyright(c) 2007 Yoshimasa Matsumoto
 */
package netjfwatcher.provision.nodemaneger.list;

import org.eclipse.jface.resource.FontRegistry;
import org.eclipse.jface.resource.JFaceResources;
import org.eclipse.jface.viewers.IFontProvider;
import org.eclipse.jface.viewers.ILabelProviderListener;
import org.eclipse.jface.viewers.ITableLabelProvider;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.graphics.Image;

/**
 * m[hXge[u Label/Font ProviderNXłB
 * 
 * @author Yoshimasa Matsumoto
 * @version 1.0
 */
public class ProvisionNodeListTableViewLabelProvider implements
		ITableLabelProvider, IFontProvider {
	/** m[hXge[uHeader */
	public static final String[] NODE_LIST_TABLE_COLUMNS = new String[] {
			"No.", "ID", "Node Name", "Group", "IP Address", "Start Date",
			"Telnet/FTP File", "Result" };

	/** m[hNo.J */
	public static final int NODE_LIST_COLUMN_NO = 0;

	/** IDJ */
	public static final int NODE_LIST_COLUMN_ID = 1;

	/** m[hJ */
	public static final int NODE_LIST_COLUMN_NODENAME = 2;

	/** m[hO[vJ */
	public static final int NODE_LIST_COLUMN_GROUP = 3;

	/** m[hIPAhXJ */
	public static final int NODE_LIST_COLUMN_IPADDRESS = 4;

	/** JnJ */
	public static final int NODE_LIST_COLUMN_START_DATE = 5;

	/** Telnet/FTPt@C J */
	public static final int NODE_LIST_COLUMN_COMMAND_FILE = 6;

	/** s J */
	public static final int NODE_LIST_COLUMN_COMMAND_RESULT = 7;

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.jface.viewers.ITableLabelProvider#getColumnImage(java.lang.Object,
	 *      int)
	 */
	public Image getColumnImage(Object element, int columnIndex) {
		return null;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.jface.viewers.ITableLabelProvider#getColumnText(java.lang.Object,
	 *      int)
	 */
	public String getColumnText(Object element, int columnIndex) {
		String[] test = (String[]) element;

		return test[columnIndex];
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.jface.viewers.IFontProvider#getFont(java.lang.Object)
	 */
	public Font getFont(Object element) {
		FontRegistry fr = JFaceResources.getFontRegistry();

		return fr.get(JFaceResources.DEFAULT_FONT);
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.jface.viewers.
	 *      IBaseLabelProvider#isLabelProperty(java.lang.Object,
	 *      java.lang.String)
	 */
	public boolean isLabelProperty(Object element, String property) {
		return true;
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.jface.viewers.
	 *      IBaseLabelProvider#addListener(org.eclipse.jface.viewers.ILabelProviderListener)
	 */
	public void addListener(ILabelProviderListener listener) {
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.jface.viewers.IBaseLabelProvider#dispose()
	 */
	public void dispose() {
	}

	/*
	 * (non-Javadoc)
	 * 
	 * @see org.eclipse.jface.viewers.
	 *      IBaseLabelProvider#removeListener(org.eclipse.jface.viewers.ILabelProviderListener)
	 */
	public void removeListener(ILabelProviderListener listener) {
	}
}
